Open Lighting Architecture: ola::plugin::renard::AbstractPlugin Class Reference

| Open Lighting Architecture 0.10.9

Loading...
Searching...
No Matches
Public Member Functions | List of all members
ola::plugin::renard::AbstractPlugin Class Referenceabstract

## Detailed Description

The interface for a plugin

Inheritance diagram for ola::plugin::renard::AbstractPlugin:

## Public Member Functions
virtual bool | LoadPreferences ()=0
| Load the preferences for a plugin and set defaults.
virtual std::string | PreferenceConfigLocation () const=0
| The location for preferences.
virtual bool | IsEnabled () const=0
| Is the plugin enabled?
virtual void | SetEnabledState (bool enable)=0
| Set the plugin's enabled state.
virtual bool | Start ()=0
| Start the plugin.
virtual bool | Stop ()=0
| Stop the plugin.
virtual ola_plugin_id | Id () const=0
| Get the plugin ID of this plugin.
virtual std::string | Name () const=0
| Get the plugin name.
virtual std::string | Description () const=0
virtual void | ConflictsWith (std::set< ola_plugin_id > *conflict_set) const=0
virtual bool | operator< (const AbstractPlugin &other) const=0

## Member Function Documentation

## ◆ Description()

virtual std::string ola::AbstractPlugin::Description | ( |  | ) | const
| pure virtual

Return the description for this plugin.

Returns
  a string description of the plugin

## ◆ Id()

virtual ola_plugin_id ola::AbstractPlugin::Id | ( |  | ) | const
| pure virtual

Get the plugin ID of this plugin.

Returns
  the ola_plugin_id of this plugin

## ◆ IsEnabled()

virtual bool ola::AbstractPlugin::IsEnabled | ( |  | ) | const
| pure virtual

Is the plugin enabled?

Returns
  true if this plugin is enabled

## ◆ Name()

virtual std::string ola::AbstractPlugin::Name | ( |  | ) | const
| pure virtual

Get the plugin name.

Returns
  the name of this plugin

## ◆ PreferenceConfigLocation()

virtual std::string ola::AbstractPlugin::PreferenceConfigLocation | ( |  | ) | const
| pure virtual

The location for preferences.

This can be anything really but should indicate to the user how the preferences were loaded.

## ◆ SetEnabledState()

virtual void ola::AbstractPlugin::SetEnabledState | ( | bool | enable | ) |
| pure virtual

Set the plugin's enabled state.

Parameters

  enable | The new enabled state

Returns
  true if this plugin is enabled

## ◆ Start()

virtual bool ola::AbstractPlugin::Start | ( |  | ) |
| pure virtual

Start the plugin.

Calls StartHook() which can be overridden by the derived classes.

Returns
  true if we started ok, false otherwise

## ◆ Stop()

virtual bool ola::AbstractPlugin::Stop | ( |  | ) |
| pure virtual

Stop the plugin.

Calls StopHook() which can be overridden by the derived classes.

Returns
  true on success, false on failure

The documentation for this class was generated from the following file:

- include/olad/Plugin.h